MyGUI::Widget Class Reference

widget description should be here. More...

`#include <MyGUI_Widget.h>`

Inheritance diagram for MyGUI::Widget:
[legend]

## Public Types

typedef RTTIBase | Base
typedef Widget | RTTIBase
Public Types inherited from MyGUI::IObject
typedef IObject | RTTIBase

## Public Member Functions

virtual std::string_view | getTypeName () const override
virtual bool | isType (const std::type_info &_type) const override
template<typename Type>
bool | isType () const
Widget * | createWidgetT (std::string_view _type, std::string_view _skin, const IntCoord &_coord, Align _align, std::string_view _name={})
Widget * | createWidgetT (std::string_view _type, std::string_view _skin, int _left, int _top, int _width, int _height, Align _align, std::string_view _name={})
Widget * | createWidgetRealT (std::string_view _type, std::string_view _skin, const FloatCoord &_coord, Align _align, std::string_view _name={})
Widget * | createWidgetRealT (std::string_view _type, std::string_view _skin, float _left, float _top, float _width, float _height, Align _align, std::string_view _name={})
template<typename T>
T * | createWidget (std::string_view _skin, const IntCoord &_coord, Align _align, std::string_view _name={})
template<typename T>
T * | createWidget (std::string_view _skin, int _left, int _top, int _width, int _height, Align _align, std::string_view _name={})
template<typename T>
T * | createWidgetReal (std::string_view _skin, const FloatCoord &_coord, Align _align, std::string_view _name={})
template<typename T>
T * | createWidgetReal (std::string_view _skin, float _left, float _top, float _width, float _height, Align _align, std::string_view _name={})
Widget * | createWidgetT (WidgetStyle _style, std::string_view _type, std::string_view _skin, const IntCoord &_coord, Align _align, std::string_view _layer={}, std::string_view _name={})
template<typename T>
T * | createWidget (WidgetStyle _style, std::string_view _skin, const IntCoord &_coord, Align _align, std::string_view _layer={}, std::string_view _name={})
void | setPosition (const IntPoint &_point) override
void | setSize (const IntSize &_size) override
void | setCoord (const IntCoord &_coord) override
void | setPosition (int _left, int _top)
void | setSize (int _width, int _height)
void | setCoord (int _left, int _top, int _width, int _height)
void | setRealPosition (const FloatPoint &_point)
void | setRealSize (const FloatSize &_size)
void | setRealCoord (const FloatCoord &_coord)
void | setRealPosition (float _left, float _top)
void | setRealSize (float _width, float _height)
void | setRealCoord (float _left, float _top, float _width, float _height)
const std::string & | getName () const
| Get name of widget.
virtual void | setVisible (bool _value)
bool | getVisible () const
void | setDepth (int _value)
int | getDepth () const
bool | getInheritedVisible () const
virtual void | setAlign (Align _value)
Align | getAlign () const
void | setAlpha (float _alpha)
float | getAlpha () const
void | setInheritsAlpha (bool _inherits)
bool | getInheritsAlpha () const
void | setColour (const Colour &_value)
bool | isRootWidget () const
Widget * | getParent () const
IntSize | getParentSize () const
EnumeratorWidgetPtr | getEnumerator () const
size_t | getChildCount () const
Widget * | getChildAt (size_t _index) const
Widget * | findWidget (std::string_view _name)
void | findWidgets (std::string_view _name, VectorWidgetPtr &_result)
virtual void | setEnabled (bool _value)
void | setEnabledSilent (bool _value)
bool | getEnabled () const
bool | getInheritedEnabled () const
IntCoord | getClientCoord () const
Widget * | getClientWidget ()
const Widget * | getClientWidget () const
void | detachFromWidget (std::string_view _layer={})
void | attachToWidget (Widget *_parent, WidgetStyle _style=WidgetStyle::Child, std::string_view _layer={})
void | changeWidgetSkin (std::string_view _skinName)
void | setWidgetStyle (WidgetStyle _style, std::string_view _layer={})
WidgetStyle | getWidgetStyle () const
void | setProperty (std::string_view _key, std::string_view _value)
virtual size_t | _getItemIndex (Widget *_item) const
void | _forcePick (Widget *_widget)
void | _initialise (WidgetStyle _style, const IntCoord &_coord, std::string_view _skinName, Widget *_parent, ICroppedRectangle *_croppedParent, std::string_view _name)
void | _shutdown ()
void | _destroyChildWidget (Widget *_widget)
void | _setContainer (Widget *_value)
Widget * | _getContainer () const
void | _setAlign (const IntSize &_oldsize, const IntSize &_newSize)
bool | _checkPoint (int _left, int _top) const
Widget * | _createSkinWidget (WidgetStyle _style, std::string_view _type, std::string_view _skin, const IntCoord &_coord, Align _align, std::string_view _layer={}, std::string_view _name={})
virtual void | _resetContainer (bool _update)
bool | _setWidgetState (std::string_view _state)
void | _updateChilds ()
Public Member Functions inherited from MyGUI::IObject
template<typename Type>
bool | isType () const
template<typename Type>
Type * | castType (bool _throw=true)
template<typename Type>
const Type * | castType (bool _throw=true) const
virtual | ~IObject ()=default
Public Member Functions inherited from MyGUI::ICroppedRectangle
virtual | ~ICroppedRectangle ()=default
ICroppedRectangle * | getCroppedParent ()
IntPoint | getPosition () const
IntSize | getSize () const
const IntCoord & | getCoord () const
const IntPoint & | getAbsolutePosition () const
IntRect | getAbsoluteRect () const
IntCoord | getAbsoluteCoord () const
int | getAbsoluteLeft () const
int | getAbsoluteTop () const
int | getLeft () const
int | getRight () const
int | getTop () const
int | getBottom () const
int | getWidth () const
int | getHeight () const
bool | _isMargin () const
int | _getViewLeft () const
int | _getViewRight () const
int | _getViewTop () const
int | _getViewBottom () const
int | _getViewWidth () const
int | _getViewHeight () const
void | _setCroppedParent (ICroppedRectangle *_parent)
const IntRect & | _getMargin () const
int | _getMarginLeft () const
int | _getMarginRight () const
int | _getMarginTop () const
int | _getMarginBottom () const
Public Member Functions inherited from MyGUI::UserData
virtual | ~UserData ()=default
void | setUserString (std::string_view _key, std::string_view _value)
std::string_view | getUserString (std::string_view _key) const
const MapString & | getUserStrings () const
bool | clearUserString (std::string_view _key)
bool | isUserString (std::string_view _key) const
void | clearUserStrings ()
void | setUserData (Any _data)
template<typename ValueType>
ValueType * | getUserData (bool _throw=true) const
void | _setInternalData (Any _data)
template<typename ValueType>
ValueType * | _getInternalData (bool _throw=true) const
Public Member Functions inherited from MyGUI::WidgetInput
virtual | ~WidgetInput ()=default
void | setNeedToolTip (bool _value)
bool | getNeedToolTip () const
void | setPointer (std::string_view _value)
const std::string & | getPointer () const
void | setNeedKeyFocus (bool _value)
bool | getNeedKeyFocus () const
void | setNeedMouseFocus (bool _value)
bool | getNeedMouseFocus () const
void | setInheritsPick (bool _value)
bool | getInheritsPick () const
void | setMaskPick (const std::string &_filename)
void | setMaskPick (const MaskPickInfo &_info)
bool | isMaskPickInside (const IntPoint &_point, const IntCoord &_coord) const
bool | getRootMouseFocus () const
bool | getRootKeyFocus () const
void | _riseMouseLostFocus (Widget *_new)
void | _riseMouseSetFocus (Widget *_old)
void | _riseMouseDrag (int _left, int _top, MouseButton _id)
void | _riseMouseMove (int _left, int _top)
void | _riseMouseWheel (int _rel)
void | _riseMouseButtonPressed (int _left, int _top, MouseButton _id)
void | _riseMouseButtonReleased (int _left, int _top, MouseButton _id)
void | _riseMouseButtonClick ()
void | _riseMouseButtonDoubleClick ()
void | _riseKeyLostFocus (Widget *_new)
void | _riseKeySetFocus (Widget *_old)
void | _riseKeyButtonPressed (KeyCode _key, Char _char)
void | _riseKeyButtonReleased (KeyCode _key)
void | _riseMouseChangeRootFocus (bool _focus)
void | _riseKeyChangeRootFocus (bool _focus)
void | _setRootMouseFocus (bool _value)
void | _setRootKeyFocus (bool _value)
Public Member Functions inherited from MyGUI::delegates::IDelegateUnlink
virtual | ~IDelegateUnlink ()=default
| IDelegateUnlink ()
bool | compare (IDelegateUnlink *_unlink) const
Public Member Functions inherited from MyGUI::SkinItem
ISubWidgetText * | getSubWidgetText () const
ISubWidgetRect * | getSubWidgetMain () const
void | _setTextureName (std::string_view _texture)
const std::string & | _getTextureName () const
Public Member Functions inherited from MyGUI::LayerItem
ILayer * | getLayer () const
ILayerNode * | getLayerNode () const
void | attachItemToNode (ILayer *_layer, ILayerNode *_node) override
void | detachFromLayer () override
void | upLayerItem () override
void | setRenderItemTexture (ITexture *_texture)
void | addChildItem (LayerItem *_item)
void | removeChildItem (LayerItem *_item)
void | addChildNode (LayerItem *_item)
void | removeChildNode (LayerItem *_item)
void | addRenderItem (ISubWidget *_item)
void | removeAllRenderItems ()
void | saveLayerItem ()
void | restoreLayerItem ()
Public Member Functions inherited from MyGUI::ILayerItem
virtual | ~ILayerItem ()=default
Public Member Functions inherited from MyGUI::MemberObsolete< Widget >
bool | isEnabled ()
bool | isInheritsAlpha ()
bool | isNeedKeyFocus ()
bool | isNeedMouseFocus ()
bool | isInheritsPick ()
bool | isVisible ()

## Static Public Member Functions

static std::string_view | getClassTypeName ()
Static Public Member Functions inherited from MyGUI::IObject
static std::string_view | getClassTypeName ()

## Data Fields

EventHandle_WidgetStringString | eventChangeProperty
EventHandle_WidgetVoid | eventChangeCoord
EventHandle_WidgetVoid | eventWidgetDestroyed
Data Fields inherited from MyGUI::WidgetInput
EventHandle_WidgetWidget | eventMouseLostFocus
EventHandle_WidgetWidget | eventMouseSetFocus
EventPairAddParameter< EventHandle_WidgetIntInt, EventHandle_WidgetIntIntButton > | eventMouseDrag
EventHandle_WidgetIntInt | eventMouseMove
EventHandle_WidgetInt | eventMouseWheel
EventHandle_WidgetIntIntButton | eventMouseButtonPressed
EventHandle_WidgetIntIntButton | eventMouseButtonReleased
EventHandle_WidgetVoid | eventMouseButtonClick
EventHandle_WidgetVoid | eventMouseButtonDoubleClick
EventHandle_WidgetWidget | eventKeyLostFocus
EventHandle_WidgetWidget | eventKeySetFocus
EventHandle_WidgetKeyCodeChar | eventKeyButtonPressed
EventHandle_WidgetKeyCode | eventKeyButtonReleased
EventHandle_WidgetBool | eventRootMouseChangeFocus
EventHandle_WidgetBool | eventRootKeyChangeFocus
EventHandle_WidgetToolTip | eventToolTip

## Protected Member Functions

| ~Widget () override=default
virtual void | shutdownOverride ()
virtual void | initialiseOverride ()
void | _updateView ()
Widget * | baseCreateWidget (WidgetStyle _style, std::string_view _type, std::string_view _skin, const IntCoord &_coord, Align _align, std::string_view _layer, std::string_view _name, bool _template)
void | _destroyAllChildWidget ()
virtual size_t | _getContainerIndex (const IntPoint &_point) const
virtual void | baseUpdateEnable ()
ILayerItem * | getLayerItemByPoint (int _left, int _top) const override
const IntCoord & | getLayerItemCoord () const override
template<typename T>
void | assignWidget (T *&_widget, std::string_view _name)
VectorWidgetPtr | getSkinWidgetsByName (std::string_view _name) const
virtual void | onWidgetCreated (Widget *_widget)
virtual void | onWidgetDestroy (Widget *_widget)
void | setWidgetClient (Widget *_widget)
Widget * | _getClientWidget ()
| If there is client widget return it, otherwise return this.
const Widget * | _getClientWidget () const
virtual void | setPropertyOverride (std::string_view _key, std::string_view _value)
Protected Member Functions inherited from MyGUI::ICroppedRectangle
bool | _checkMargin ()
bool | _checkOutside () const
Protected Member Functions inherited from MyGUI::WidgetInput
virtual void | onMouseLostFocus (Widget *_new)
virtual void | onMouseSetFocus (Widget *_old)
virtual void | onMouseDrag (int _left, int _top, MouseButton _id)
virtual void | onMouseMove (int _left, int _top)
virtual void | onMouseWheel (int _rel)
virtual void | onMouseButtonPressed (int _left, int _top, MouseButton _id)
virtual void | onMouseButtonReleased (int _left, int _top, MouseButton _id)
virtual void | onMouseButtonClick ()
virtual void | onMouseButtonDoubleClick ()
virtual void | onKeyLostFocus (Widget *_new)
virtual void | onKeySetFocus (Widget *_old)
virtual void | onKeyButtonPressed (KeyCode _key, Char _char)
virtual void | onKeyButtonReleased (KeyCode _key)
virtual void | onMouseChangeRootFocus (bool _focus)
virtual void | onKeyChangeRootFocus (bool _focus)
Protected Member Functions inherited from MyGUI::SkinItem
void | _createSkinItem (ResourceSkin *_info)
void | _deleteSkinItem ()
void | _setSkinItemAlign (const IntSize &_size)
void | _setSkinItemVisible (bool _value)
void | _setSkinItemColour (const Colour &_value)
void | _setSkinItemAlpha (float _value)
void | _correctSkinItemView ()
void | _updateSkinItemView ()
bool | _setSkinItemState (std::string_view _state)
void | _setSubSkinVisible (bool _visible)
Protected Member Functions inherited from MyGUI::LayerItem
void | attachToLayerItemNode (ILayerNode *_item, bool _deep)
void | detachFromLayerItemNode (bool _deep)

## Friends

class | WidgetManager

## Additional Inherited Members

Protected Attributes inherited from MyGUI::ICroppedRectangle
IntRect | mMargin
IntCoord | mCoord
IntPoint | mAbsolutePosition
bool | mIsMargin {false}
ICroppedRectangle * | mCroppedParent {nullptr}

## Detailed Description

widget description should be here.

Definition at line 32 of file MyGUI_Widget.h.

## Member Typedef Documentation

## Base

typedef RTTIBase MyGUI::Widget::Base

Definition at line 44 of file MyGUI_Widget.h.

## RTTIBase

typedef Widget MyGUI::Widget::RTTIBase

Definition at line 44 of file MyGUI_Widget.h.

## Constructor & Destructor Documentation

## ~Widget()

MyGUI::Widget::~Widget | ( |  | ) |

override protected default

## Member Function Documentation

## _checkPoint()

bool MyGUI::Widget::_checkPoint | ( | int | _left,
|  | int | _top ) const

Definition at line 1098 of file MyGUI_Widget.cpp.

## _createSkinWidget()

Widget * MyGUI::Widget::_createSkinWidget | ( | WidgetStyle | _style,
|  | std::string_view | _type,
|  | std::string_view | _skin,
|  | const IntCoord & | _coord,
|  | Align | _align,
|  | std::string_view | _layer = {},
|  | std::string_view | _name = {} )

Definition at line 1206 of file MyGUI_Widget.cpp.

## _destroyAllChildWidget()

void MyGUI::Widget::_destroyAllChildWidget | ( |  | ) |

protected

Definition at line 442 of file MyGUI_Widget.cpp.

## _destroyChildWidget()

void MyGUI::Widget::_destroyChildWidget | ( | Widget * | _widget | ) |

Definition at line 411 of file MyGUI_Widget.cpp.

## _forcePick()

void MyGUI::Widget::_forcePick | ( | Widget * | _widget | ) |

Definition at line 547 of file MyGUI_Widget.cpp.

## _getClientWidget() [1/2]

Widget * MyGUI::Widget::_getClientWidget | ( |  | ) |

protected

If there is client widget return it, otherwise return this.

Definition at line 1196 of file MyGUI_Widget.cpp.

## _getClientWidget() [2/2]

const Widget * MyGUI::Widget::_getClientWidget | ( |  | ) | const

protected

Definition at line 1201 of file MyGUI_Widget.cpp.

## _getContainer()

Widget * MyGUI::Widget::_getContainer | ( |  | ) | const

Definition at line 1392 of file MyGUI_Widget.cpp.

## _getContainerIndex()

size_t MyGUI::Widget::_getContainerIndex | ( | const IntPoint & | _point | ) | const

protected virtual

Reimplemented in MyGUI::ItemBox.

Definition at line 1397 of file MyGUI_Widget.cpp.

## _getItemIndex()

size_t MyGUI::Widget::_getItemIndex | ( | Widget * | _item | ) | const

virtual

Reimplemented in MyGUI::ItemBox, and MyGUI::ListBox.

Definition at line 1382 of file MyGUI_Widget.cpp.

## _initialise()

void MyGUI::Widget::_initialise | ( | WidgetStyle | _style,
|  | const IntCoord & | _coord,
|  | std::string_view | _skinName,
|  | Widget * | _parent,
|  | ICroppedRectangle * | _croppedParent,
|  | std::string_view | _name )

Definition at line 31 of file MyGUI_Widget.cpp.

## _resetContainer()

void MyGUI::Widget::_resetContainer | ( | bool | _update | ) |

virtual

Reimplemented in MyGUI::ComboBox, MyGUI::ItemBox, and MyGUI::ListBox.

Definition at line 1092 of file MyGUI_Widget.cpp.

## _setAlign()

void MyGUI::Widget::_setAlign | ( | const IntSize & | _oldsize,
|  | const IntSize & | _newSize )

Definition at line 612 of file MyGUI_Widget.cpp.

## _setContainer()

void MyGUI::Widget::_setContainer | ( | Widget * | _value | ) |

Definition at line 1387 of file MyGUI_Widget.cpp.

## _setWidgetState()

bool MyGUI::Widget::_setWidgetState | ( | std::string_view | _state | ) |

Definition at line 406 of file MyGUI_Widget.cpp.

## _shutdown()

void MyGUI::Widget::_shutdown | ( |  | ) |

Definition at line 112 of file MyGUI_Widget.cpp.

## _updateChilds()

void MyGUI::Widget::_updateChilds | ( |  | ) |

Definition at line 1467 of file MyGUI_Widget.cpp.

## _updateView()

void MyGUI::Widget::_updateView | ( |  | ) |

protected

Definition at line 359 of file MyGUI_Widget.cpp.

## assignWidget()

template<typename T>

void MyGUI::Widget::assignWidget | ( | T *& | _widget,
|  | std::string_view | _name )

inline protected

Definition at line 413 of file MyGUI_Widget.h.

## attachToWidget()

void MyGUI::Widget::attachToWidget | ( | Widget * | _parent,
|  | WidgetStyle | _style = WidgetStyle::Child,
|  | std::string_view | _layer = {} )

Attach widget to parent

Parameters

  _parent | New parent
  _style | New widget style (see WidgetStyle::Enum)
  _layer | Attach to specified layer (if any)

Definition at line 842 of file MyGUI_Widget.cpp.

## baseCreateWidget()

Widget * MyGUI::Widget::baseCreateWidget | ( | WidgetStyle | _style,
|  | std::string_view | _type,
|  | std::string_view | _skin,
|  | const IntCoord & | _coord,
|  | Align | _align,
|  | std::string_view | _layer,
|  | std::string_view | _name,
|  | bool | _template )

protected

Definition at line 293 of file MyGUI_Widget.cpp.

## baseUpdateEnable()

void MyGUI::Widget::baseUpdateEnable | ( |  | ) |

protected virtual

Reimplemented in MyGUI::Button.

Definition at line 1014 of file MyGUI_Widget.cpp.

## changeWidgetSkin()

void MyGUI::Widget::changeWidgetSkin | ( | std::string_view | _skinName | ) |

Change widget skin

Definition at line 143 of file MyGUI_Widget.cpp.

## createWidget() [1/3]

template<typename T>

T * MyGUI::Widget::createWidget | ( | std::string_view | _skin,
|  | const IntCoord & | _coord,
|  | Align | _align,
|  | std::string_view | _name = {} )

inline

Same as Widget::createWidgetT but return T pointer instead of Widget*

Definition at line 94 of file MyGUI_Widget.h.

## createWidget() [2/3]

template<typename T>

T * MyGUI::Widget::createWidget | ( | std::string_view | _skin,
|  | int | _left,
|  | int | _top,
|  | int | _width,
|  | int | _height,
|  | Align | _align,
|  | std::string_view | _name = {} )

inline

Same as Widget::createWidgetT but return T pointer instead of Widget*

Definition at line 101 of file MyGUI_Widget.h.

## createWidget() [3/3]

template<typename T>

T * MyGUI::Widget::createWidget | ( | WidgetStyle | _style,
|  | std::string_view | _skin,
|  | const IntCoord & | _coord,
|  | Align | _align,
|  | std::string_view | _layer = {},
|  | std::string_view | _name = {} )

inline

Same as Widget::createWidgetT but return T* instead of Widget*

Definition at line 156 of file MyGUI_Widget.h.

## createWidgetReal() [1/2]

template<typename T>

T * MyGUI::Widget::createWidgetReal | ( | std::string_view | _skin,
|  | const FloatCoord & | _coord,
|  | Align | _align,
|  | std::string_view | _name = {} )

inline

Same as Widget::createWidgetRealT but return T* instead of Widget*

Definition at line 116 of file MyGUI_Widget.h.

## createWidgetReal() [2/2]

template<typename T>

T * MyGUI::Widget::createWidgetReal | ( | std::string_view | _skin,
|  | float | _left,
|  | float | _top,
|  | float | _width,
|  | float | _height,
|  | Align | _align,
|  | std::string_view | _name = {} )

inline

Same as Widget::createWidgetRealT but return T* instead of Widget*

Definition at line 123 of file MyGUI_Widget.h.

## createWidgetRealT() [1/2]

Widget * MyGUI::Widget::createWidgetRealT | ( | std::string_view | _type,
|  | std::string_view | _skin,
|  | const FloatCoord & | _coord,
|  | Align | _align,
|  | std::string_view | _name = {} )

Create widget using coordinates relative to parent. see Widget::createWidgetT(std::string_view _type, std::string_view _skin, const IntCoord& _coord, Align _align, std::string_view _name = {})

Definition at line 349 of file MyGUI_Widget.cpp.

## createWidgetRealT() [2/2]

Widget * MyGUI::Widget::createWidgetRealT | ( | std::string_view | _type,
|  | std::string_view | _skin,
|  | float | _left,
|  | float | _top,
|  | float | _width,
|  | float | _height,
|  | Align | _align,
|  | std::string_view | _name = {} )

Create widget using coordinates relative to parent. see Widget::createWidgetT(std::string_view _type, std::string_view _skin, const IntCoord& _coord, Align _align, std::string_view _name = {})

Definition at line 967 of file MyGUI_Widget.cpp.

## createWidgetT() [1/3]

Widget * MyGUI::Widget::createWidgetT | ( | std::string_view | _type,
|  | std::string_view | _skin,
|  | const IntCoord & | _coord,
|  | Align | _align,
|  | std::string_view | _name = {} )

Create child widget

Parameters

  _type | widget type
  _skin | widget skin
  _coord | int coordinates of widget (_left, _top, _width, _height)
  _align | widget align (possible values can be found in enum Align)
  _name | if needed (you can use it for finding widget by name later)

Definition at line 944 of file MyGUI_Widget.cpp.

## createWidgetT() [2/3]

Widget * MyGUI::Widget::createWidgetT | ( | std::string_view | _type,
|  | std::string_view | _skin,
|  | int | _left,
|  | int | _top,
|  | int | _width,
|  | int | _height,
|  | Align | _align,
|  | std::string_view | _name = {} )

See Widget::createWidgetT(std::string_view _type, std::string_view _skin, const IntCoord& _coord, Align _align, std::string_view _name = {})

Definition at line 954 of file MyGUI_Widget.cpp.

## createWidgetT() [3/3]

Widget * MyGUI::Widget::createWidgetT | ( | WidgetStyle | _style,
|  | std::string_view | _type,
|  | std::string_view | _skin,
|  | const IntCoord & | _coord,
|  | Align | _align,
|  | std::string_view | _layer = {},
|  | std::string_view | _name = {} )

Create child widget

Parameters

  _style | Child, Popup or Overlapped widget style
  _type | widget type
  _skin | widget skin
  _coord | int coordinates of widget (_left, _top, _width, _height)
  _align | widget align (possible values can be found in enum Align)
  _layer | layer where widget will be created (all layers usually defined in core_layer.xml file).
  _name | optional widget name (you can use it for finding widget by name later)

Definition at line 980 of file MyGUI_Widget.cpp.

## detachFromWidget()

void MyGUI::Widget::detachFromWidget | ( | std::string_view | _layer = {} | ) |

Detach widget from widgets hierarchy

Parameters

  _layer | Attach to specified layer (if any)

Definition at line 780 of file MyGUI_Widget.cpp.

## findWidget()

Widget * MyGUI::Widget::findWidget | ( | std::string_view | _name | ) |

Find widget by name. Search recursively through all childs starting from this widget.

Returns
  Return first found widget with given name

Definition at line 575 of file MyGUI_Widget.cpp.

## findWidgets()

void MyGUI::Widget::findWidgets | ( | std::string_view | _name,
|  | VectorWidgetPtr & | _result )

Find all widgets with given name and add them into _result. Search recursively through all childs starting from this widget.

Definition at line 1166 of file MyGUI_Widget.cpp.

## getAlign()

Align MyGUI::Widget::getAlign | ( |  | ) | const

Get align

Definition at line 1332 of file MyGUI_Widget.cpp.

## getAlpha()

float MyGUI::Widget::getAlpha | ( |  | ) | const

Get widget opacity

Definition at line 1337 of file MyGUI_Widget.cpp.

## getChildAt()

Widget * MyGUI::Widget::getChildAt | ( | size_t | _index | ) | const

Get child by index (index from 0 to child_count - 1)

Definition at line 1006 of file MyGUI_Widget.cpp.

## getChildCount()

size_t MyGUI::Widget::getChildCount | ( |  | ) | const

Get child count

Definition at line 999 of file MyGUI_Widget.cpp.

## getClassTypeName()

std::string_view MyGUI::Widget::getClassTypeName | ( |  | ) |

inline static

Definition at line 44 of file MyGUI_Widget.h.

## getClientCoord()

IntCoord MyGUI::Widget::getClientCoord | ( |  | ) | const

Get rectangle where child widgets placed

Definition at line 459 of file MyGUI_Widget.cpp.

## getClientWidget() [1/2]

Widget * MyGUI::Widget::getClientWidget | ( |  | ) |

Get client area widget or nullptr if widget don't have client

Definition at line 1367 of file MyGUI_Widget.cpp.

## getClientWidget() [2/2]

const Widget * MyGUI::Widget::getClientWidget | ( |  | ) | const

Definition at line 1372 of file MyGUI_Widget.cpp.

## getDepth()

int MyGUI::Widget::getDepth | ( |  | ) | const

Get child widget rendering depth

Definition at line 1442 of file MyGUI_Widget.cpp.

## getEnabled()

bool MyGUI::Widget::getEnabled | ( |  | ) | const

Is widget enabled

Definition at line 1362 of file MyGUI_Widget.cpp.

## getEnumerator()

EnumeratorWidgetPtr MyGUI::Widget::getEnumerator | ( |  | ) | const

Get child widgets Enumerator

Definition at line 992 of file MyGUI_Widget.cpp.

## getInheritedEnabled()

bool MyGUI::Widget::getInheritedEnabled | ( |  | ) | const

Is widget enabled and all it's parents in hierarchy are enabled.

Definition at line 1412 of file MyGUI_Widget.cpp.

## getInheritedVisible()

bool MyGUI::Widget::getInheritedVisible | ( |  | ) | const

Return widget's visibility based on it's and parents visibility.

Definition at line 1417 of file MyGUI_Widget.cpp.

## getInheritsAlpha()

bool MyGUI::Widget::getInheritsAlpha | ( |  | ) | const

Get inherits alpha mode flag

Definition at line 1342 of file MyGUI_Widget.cpp.

## getLayerItemByPoint()

ILayerItem * MyGUI::Widget::getLayerItemByPoint | ( | int | _left,
|  | int | _top ) const

override protected virtual

Implements MyGUI::ILayerItem.

Definition at line 496 of file MyGUI_Widget.cpp.

## getLayerItemCoord()

const IntCoord & MyGUI::Widget::getLayerItemCoord | ( |  | ) | const

override protected virtual

Implements MyGUI::ILayerItem.

Definition at line 1402 of file MyGUI_Widget.cpp.

## getName()

const std::string & MyGUI::Widget::getName | ( |  | ) | const

Get name of widget.

Definition at line 1322 of file MyGUI_Widget.cpp.

## getParent()

Widget * MyGUI::Widget::getParent | ( |  | ) | const

Get parent widget or nullptr if no parent

Definition at line 1352 of file MyGUI_Widget.cpp.

## getParentSize()

IntSize MyGUI::Widget::getParentSize | ( |  | ) | const

Get parent widget size. If there is no parent get layer size

Definition at line 1082 of file MyGUI_Widget.cpp.

## getSkinWidgetsByName()

VectorWidgetPtr MyGUI::Widget::getSkinWidgetsByName | ( | std::string_view | _name | ) | const

protected

Definition at line 1156 of file MyGUI_Widget.cpp.

## getTypeName()

virtual std::string_view MyGUI::Widget::getTypeName | ( |  | ) | const

inline override virtual

Get type name as string

Reimplemented from MyGUI::IObject.

Reimplemented in MyGUI::Button, MyGUI::Canvas, MyGUI::ComboBox, MyGUI::DDContainer, MyGUI::EditBox, MyGUI::HScroll, MyGUI::ImageBox, MyGUI::ItemBox, MyGUI::ListBox, MyGUI::MenuBar, MyGUI::MenuControl, MyGUI::MenuItem, MyGUI::MultiListBox, MyGUI::MultiListItem, MyGUI::PopupMenu, MyGUI::ProgressBar, MyGUI::ScrollBar, MyGUI::ScrollView, MyGUI::TabControl, MyGUI::TabItem, MyGUI::TextBox, MyGUI::VScroll, and MyGUI::Window.

Definition at line 44 of file MyGUI_Widget.h.

## getVisible()

bool MyGUI::Widget::getVisible | ( |  | ) | const

Return true if visible

Definition at line 1327 of file MyGUI_Widget.cpp.

## getWidgetStyle()

WidgetStyle MyGUI::Widget::getWidgetStyle | ( |  | ) | const

Get widget style

Definition at line 1377 of file MyGUI_Widget.cpp.

## initialiseOverride()

void MyGUI::Widget::initialiseOverride | ( |  | ) |

protected virtual

Reimplemented in MyGUI::Button, MyGUI::Canvas, MyGUI::ComboBox, MyGUI::EditBox, MyGUI::ItemBox, MyGUI::ListBox, MyGUI::MenuControl, MyGUI::MenuItem, MyGUI::MultiListBox, MyGUI::MultiListItem, MyGUI::ProgressBar, MyGUI::ScrollBar, MyGUI::ScrollView, MyGUI::TabControl, MyGUI::TabItem, and MyGUI::Window.

Definition at line 1122 of file MyGUI_Widget.cpp.

## isRootWidget()

bool MyGUI::Widget::isRootWidget | ( |  | ) | const

Is this widget is root widget (root == without parents)

Definition at line 1347 of file MyGUI_Widget.cpp.

## isType() [1/2]

template<typename Type>

bool MyGUI::Widget::isType | ( |  | ) | const

inline

Compare with selected type

Definition at line 44 of file MyGUI_Widget.h.

## isType() [2/2]

virtual bool MyGUI::Widget::isType | ( | const std::type_info & | _type | ) | const

inline override virtual

Compare with selected type

Reimplemented from MyGUI::IObject.

Reimplemented in MyGUI::Button, MyGUI::Canvas, MyGUI::ComboBox, MyGUI::DDContainer, MyGUI::EditBox, MyGUI::HScroll, MyGUI::ImageBox, MyGUI::ItemBox, MyGUI::ListBox, MyGUI::MenuBar, MyGUI::MenuControl, MyGUI::MenuItem, MyGUI::MultiListBox, MyGUI::MultiListItem, MyGUI::PopupMenu, MyGUI::ProgressBar, MyGUI::ScrollBar, MyGUI::ScrollView, MyGUI::TabControl, MyGUI::TabItem, MyGUI::TextBox, MyGUI::VScroll, and MyGUI::Window.

Definition at line 44 of file MyGUI_Widget.h.

## onWidgetCreated()

void MyGUI::Widget::onWidgetCreated | ( | Widget * | _widget | ) |

protected virtual

Reimplemented in MyGUI::MenuControl, MyGUI::MenuItem, MyGUI::MultiListBox, and MyGUI::TabControl.

Definition at line 1182 of file MyGUI_Widget.cpp.

## onWidgetDestroy()

void MyGUI::Widget::onWidgetDestroy | ( | Widget * | _widget | ) |

protected virtual

Reimplemented in MyGUI::MultiListBox.

Definition at line 1186 of file MyGUI_Widget.cpp.

## setAlign()

void MyGUI::Widget::setAlign | ( | Align | _value | ) |

virtual

Set align

Definition at line 775 of file MyGUI_Widget.cpp.

## setAlpha()

void MyGUI::Widget::setAlpha | ( | float | _alpha | ) |

Set widget opacity

Definition at line 466 of file MyGUI_Widget.cpp.

## setColour()

void MyGUI::Widget::setColour | ( | const Colour & | _value | ) |

Definition at line 1074 of file MyGUI_Widget.cpp.

## setCoord() [1/2]

void MyGUI::Widget::setCoord | ( | const IntCoord & | _coord | ) |

override virtual

Set widget position and size

Reimplemented from MyGUI::ICroppedRectangle.

Reimplemented in MyGUI::Window.

Definition at line 730 of file MyGUI_Widget.cpp.

## setCoord() [2/2]

void MyGUI::Widget::setCoord | ( | int | _left,
|  | int | _top,
|  | int | _width,
|  | int | _height )

See Widget::setCoord(const IntCoord& _coord)

Definition at line 1302 of file MyGUI_Widget.cpp.

## setDepth()

void MyGUI::Widget::setDepth | ( | int | _value | ) |

Set child widget rendering depth for ordering child widgets. Widget with higher depth is rendered below widget with lower depth. Available only for child widgets. For root widgets use layer property instead.

Definition at line 1427 of file MyGUI_Widget.cpp.

## setEnabled()

void MyGUI::Widget::setEnabled | ( | bool | _value | ) |

virtual

Enable or disable widget

Definition at line 1049 of file MyGUI_Widget.cpp.

## setEnabledSilent()

void MyGUI::Widget::setEnabledSilent | ( | bool | _value | ) |

Enable or disable widget without changing widget's state

Definition at line 1357 of file MyGUI_Widget.cpp.

## setInheritsAlpha()

void MyGUI::Widget::setInheritsAlpha | ( | bool | _inherits | ) |

Enable or disable inherits alpha mode.
Inherits alpha mode: when enabled widget alpha is it's own alpha value multiplied by parent's real alpha (that depend on parent's parent and so on).
When disabled widget's alpha doesn't depend on parent's alpha. So this is used when you need things like semi-transparent window with non-transparent text on it and window's alpha changes.
Enabled (true) by default.

Definition at line 490 of file MyGUI_Widget.cpp.

## setPosition() [1/2]

void MyGUI::Widget::setPosition | ( | const IntPoint & | _point | ) |

override virtual

Set widget position (position of left top corner)

Reimplemented from MyGUI::ICroppedRectangle.

Reimplemented in MyGUI::Window.

Definition at line 676 of file MyGUI_Widget.cpp.

## setPosition() [2/2]

void MyGUI::Widget::setPosition | ( | int | _left,
|  | int | _top )

See Widget::setPosition(const IntPoint& _pos)

Definition at line 1292 of file MyGUI_Widget.cpp.

## setProperty()

void MyGUI::Widget::setProperty | ( | std::string_view | _key,
|  | std::string_view | _value )

Set any widget property

Parameters

  _key | Property name (for example Alpha or Enabled)
  _value | Value converted to string

Definition at line 1135 of file MyGUI_Widget.cpp.

## setPropertyOverride()

void MyGUI::Widget::setPropertyOverride | ( | std::string_view | _key,
|  | std::string_view | _value )

protected virtual

Reimplemented in MyGUI::Button, MyGUI::ComboBox, MyGUI::DDContainer, MyGUI::EditBox, MyGUI::ImageBox, MyGUI::ItemBox, MyGUI::ListBox, MyGUI::MenuControl, MyGUI::MenuItem, MyGUI::MultiListItem, MyGUI::ProgressBar, MyGUI::ScrollBar, MyGUI::ScrollView, MyGUI::TabControl, MyGUI::TabItem, MyGUI::TextBox, and MyGUI::Window.

Definition at line 1218 of file MyGUI_Widget.cpp.

## setRealCoord() [1/2]

void MyGUI::Widget::setRealCoord | ( | const FloatCoord & | _coord | ) |

Set widget position and size

Definition at line 605 of file MyGUI_Widget.cpp.

## setRealCoord() [2/2]

void MyGUI::Widget::setRealCoord | ( | float | _left,
|  | float | _top,
|  | float | _width,
|  | float | _height )

See Widget::setRealPosition(const FloatCoord& _coord)

Definition at line 1317 of file MyGUI_Widget.cpp.

## setRealPosition() [1/2]

void MyGUI::Widget::setRealPosition | ( | const FloatPoint & | _point | ) |

Set widget position (position of left top corner)

Definition at line 591 of file MyGUI_Widget.cpp.

## setRealPosition() [2/2]

void MyGUI::Widget::setRealPosition | ( | float | _left,
|  | float | _top )

See Widget::setRealPosition(const FloatPoint& _point)

Definition at line 1307 of file MyGUI_Widget.cpp.

## setRealSize() [1/2]

void MyGUI::Widget::setRealSize | ( | const FloatSize & | _size | ) |

Set widget size

Definition at line 598 of file MyGUI_Widget.cpp.

## setRealSize() [2/2]

void MyGUI::Widget::setRealSize | ( | float | _width,
|  | float | _height )

See Widget::setRealSize(const FloatSize& _size)

Definition at line 1312 of file MyGUI_Widget.cpp.

## setSize() [1/2]

void MyGUI::Widget::setSize | ( | const IntSize & | _size | ) |

override virtual

Set widget size

Reimplemented from MyGUI::ICroppedRectangle.

Reimplemented in MyGUI::Window.

Definition at line 693 of file MyGUI_Widget.cpp.

## setSize() [2/2]

void MyGUI::Widget::setSize | ( | int | _width,
|  | int | _height )

See Widget::setSize(const IntSize& _size)

Definition at line 1297 of file MyGUI_Widget.cpp.

## setVisible()

void MyGUI::Widget::setVisible | ( | bool | _value | ) |

virtual

Hide or show widget

Reimplemented in MyGUI::MenuControl, and MyGUI::Window.

Definition at line 1022 of file MyGUI_Widget.cpp.

## setWidgetClient()

void MyGUI::Widget::setWidgetClient | ( | Widget * | _widget | ) |

protected

Definition at line 1190 of file MyGUI_Widget.cpp.

## setWidgetStyle()

void MyGUI::Widget::setWidgetStyle | ( | WidgetStyle | _style,
|  | std::string_view | _layer = {} )

Set widget style.

Parameters

  _style | New widget style (see WidgetStyle::Enum)
  _layer | Attach to specified layer (if any)

Note
  When choosing WidgetStyle::Popup style you also need attach widget to layer

Definition at line 930 of file MyGUI_Widget.cpp.

## shutdownOverride()

void MyGUI::Widget::shutdownOverride | ( |  | ) |

protected virtual

Reimplemented in MyGUI::Button, MyGUI::Canvas, MyGUI::ComboBox, MyGUI::EditBox, MyGUI::ImageBox, MyGUI::ItemBox, MyGUI::ListBox, MyGUI::MenuControl, MyGUI::MenuItem, MyGUI::MultiListBox, MyGUI::MultiListItem, MyGUI::ProgressBar, MyGUI::ScrollBar, MyGUI::ScrollView, MyGUI::TabControl, MyGUI::TabItem, and MyGUI::Window.

Definition at line 1118 of file MyGUI_Widget.cpp.

## Friends And Related Symbol Documentation

## WidgetManager

friend class WidgetManager

friend

Definition at line 42 of file MyGUI_Widget.h.

## Field Documentation

## eventChangeCoord

EventHandle_WidgetVoid MyGUI::Widget::eventChangeCoord

Event : Widget coordinate changed (widget was resized or moved).
signature : void method(MyGUI::Widget* _sender)

Parameters

  _sender | widget that called this event

Definition at line 330 of file MyGUI_Widget.h.

## eventChangeProperty

EventHandle_WidgetStringString MyGUI::Widget::eventChangeProperty

Event : Widget property changed through setProperty (in code, or from layout)
signature : void method(MyGUI::Widget* _sender, std::string_view _key, std::string_view _value);

Parameters

  _sender | widget that called this event
  _key |
  _value |

Definition at line 324 of file MyGUI_Widget.h.

## eventWidgetDestroyed

EventHandle_WidgetVoid MyGUI::Widget::eventWidgetDestroyed

Event : Widget is about to be destroyed, but its content is valid at this point.
signature : void method(MyGUI::Widget* _sender)

Parameters

  _sender | widget that called this event

Definition at line 336 of file MyGUI_Widget.h.

The documentation for this class was generated from the following files:

- MyGUI_Widget.h
- MyGUI_Widget.cpp